import * as dntShim from "../../_dnt.shims.js";
/** Decrypts discrete encrypted chunks prefixed with a 12 byte initialisation value.  */
export declare class DecryptStream {
    private transform;
    readable: dntShim.ReadableStream<Uint8Array>;
    writable: dntShim.WritableStream<Uint8Array>;
    constructor(derivedKey: dntShim.CryptoKey);
}
/** Given a stream of potentially multiple and / or truncated chunks with an encrypted length delimiter, finds encrypted length delimiters and uses that to enqueue discrete chunks */
export declare class DecryptLengthDelimitStream {
    private transform;
    readable: dntShim.ReadableStream<Uint8Array>;
    writable: dntShim.WritableStream<Uint8Array>;
    private carryOver;
    private derivedKey;
    constructor(derivedKey: dntShim.CryptoKey);
    private getCarryOver;
    private setCarryOver;
    private delimit;
    private getLength;
}
