import * as dntShim from "../../_dnt.shims.js";
import { ITcpConn } from "../tcp/types.js";
import { NotSupportedError } from "../util/errors.js";
import { GetTransferOpts, ISyncPartner, SyncAppetite, SyncerEvent } from "./syncer_types.js";
export declare class PartnerTcp<IncomingTransferSourceType extends ITcpConn> implements ISyncPartner<IncomingTransferSourceType> {
    concurrentTransfers: number;
    payloadThreshold: number;
    rangeDivision: number;
    syncAppetite: SyncAppetite;
    private messageConn;
    private encoder;
    private decoder;
    private incomingQueue;
    private derivedKey;
    private port;
    constructor(conn: ITcpConn, appetite: SyncAppetite, encryptionKey: dntShim.CryptoKey, port: number);
    sendEvent(event: SyncerEvent): Promise<void>;
    private encryptBytes;
    getEvents(): AsyncIterable<SyncerEvent>;
    closeConnection(): Promise<void>;
    getDownload(opts: GetTransferOpts): Promise<dntShim.ReadableStream<Uint8Array> | NotSupportedError | undefined>;
    handleUploadRequest(_opts: GetTransferOpts): Promise<NotSupportedError | dntShim.WritableStream<Uint8Array>>;
    handleTransferRequest(source: ITcpConn, kind: "upload" | "download"): Promise<NotSupportedError | dntShim.WritableStream<Uint8Array> | dntShim.ReadableStream<Uint8Array> | undefined>;
}
