/// <reference types="node" />
import * as dntShim from "../../_dnt.shims.js";
import { ITcpConn, ITcpListener, ITcpProvider } from "./types.js";
import { Server, Socket } from "net";
export declare class TcpProvider implements ITcpProvider {
    listen(opts: {
        port: number;
    }): TcpListener;
    connect(opts: {
        port: number;
        hostname: string;
    }): Promise<ITcpConn>;
}
export declare class TcpListener implements ITcpListener {
    server: Server;
    private connQueue;
    constructor(server: Server);
    close(): void;
    [Symbol.asyncIterator](): AsyncGenerator<TcpConn, void, unknown>;
}
declare class TcpConn implements ITcpConn {
    private socket;
    writable: dntShim.WritableStream<Uint8Array>;
    private socketReader;
    id: number;
    constructor(socket: Socket);
    get readable(): dntShim.ReadableStream<Uint8Array>;
    read(bytes: Uint8Array): Promise<number | null>;
    write(bytes: Uint8Array): Promise<number | null>;
    close(): Socket;
    get remoteAddr(): {
        hostname: string;
        port: number;
    };
}
export {};
