import * as dntShim from "../../_dnt.shims.js";
export interface ITcpConn {
    read(bytes: Uint8Array): Promise<number | null>;
    write(bytes: Uint8Array): Promise<number | null>;
    readable: dntShim.ReadableStream<Uint8Array>;
    writable: dntShim.WritableStream<Uint8Array>;
    close(): void;
    remoteAddr: {
        hostname: string;
        port: number;
    };
}
export interface ITcpListener extends AsyncIterable<ITcpConn> {
    close(): void;
}
export interface ITcpProvider {
    listen(opts: {
        port: number;
    }): ITcpListener;
    connect(opts: {
        port: number;
        hostname: string;
    }): Promise<ITcpConn>;
}
